﻿// Atac Template Engine
// Copyright (C) 2011 Markus Jahn <markus.jahn@gmx.at>
//
// This file is part of Atac Template Engine.
//
// Atac Template Engine is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Atac Template Engine is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Atac Template Engine.  If not, see <http://www.gnu.org/licenses/>.

namespace Atac.TemplateEngine.Tests {
  public enum NodeKind {
    // Declarations
    ProgramDecl,
    UnitDecl,
    TypeDecl,
    EnumDecl,
    ConstDecl,
    VarDecl,
    ProcDecl,
    FuncDecl,
    ConstrDecl,

    // Declaration Identifiers
    ProgramId,
    UnitId,
    TypeId,
    EnumId,
    ConstId,
    VarId,
    ProcId,
    FuncId,
    ConstrId,


    // Using Directive
    Using,

    // Structured Types
    ClassType,
    InterfaceType,
    RecordType,
    ArrayType,
    EnumType,

    // Ordinal Types
    Boolean,
    Byte,
    Char,
    Integer,
    Long,

    // Real Types
    Single,
    Double,

    // String Type
    String,

    // Statements
    Assign,
    If,
    IfElse,
    Switch,
    For,
    While,
    DoWhile,
    Call,
    Block,
    GoTo,
    Try,
    Throw,

    // Statement subnodes
    Catch,
    Finally,

    // Designators
    Unit,
    Type,
    Const,
    Enum,
    Var,
    Proc,
    Func,
    Contstr,

    // Expressions
    Equals,
    NotEquals,
    Less,
    LessEquals,
    Greater,
    GreaterEquals,

    // Simple Expressions
    SignPlus,
    SignMinus,
    AriPlus,
    AriMinus,
    StrPlus,
    BoolOr,
    BoolXor,
    BitOr,
    BitXor,

    // Term
    AriMul,
    AriDiv,
    AriMod,
    BoolAnd,
    BitAnd,
    BitShl,
    BitShr,

    // Factor
    IntVal,
    HexVal,
    RealVal,
    StrVal,
    Not,
    Pars,
    TypeCast,
    Indexer,
  }
}