﻿// Atac Template Engine
// Copyright (C) 2011 Markus Jahn <markus.jahn@gmx.at>
//
// This file is part of Atac Template Engine.
//
// Atac Template Engine is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Atac Template Engine is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Atac Template Engine.  If not, see <http://www.gnu.org/licenses/>.

namespace Atac.TemplateEngine.Tests.MemberNodes {
  public interface IFactor : ITerm { }

  public class IntVal : IFactor {
    public int Value { get; private set; }

    public IntVal(int value) {
      Value = value;
    }

    public override string ToString() {
      return Value.ToString();
    }
  }

  public class StrVal : IFactor {
    public string Value { get; private set; }

    public StrVal(string value) {
      Value = value;
    }

    public override string ToString() {
      return Value;
    }
  }
}