﻿// Atac Template Engine
// Copyright (C) 2011 Markus Jahn <markus.jahn@gmx.at>
//
// This file is part of Atac Template Engine.
//
// Atac Template Engine is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Atac Template Engine is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Atac Template Engine.  If not, see <http://www.gnu.org/licenses/>.

namespace Atac.TemplateEngine.Tests.MemberNodes {
  public interface ISimpleExpression : IExpression { }
  public abstract class SimpleExpression : ISimpleExpression {
    public ITerm Left { get; private set; }
    public ITerm Right { get; private set; }

    protected SimpleExpression(ITerm left, ITerm right) {
      Left = left;
      Right = right;
    }
  }

  public class AriPlus : SimpleExpression {
    public AriPlus(IFactor left, IFactor right) : base(left, right) {}
    public override string ToString() {
      return "+";
    }
  }

  public class AriMinus : SimpleExpression {
    public AriMinus(IFactor left, IFactor right) : base(left, right) { }
    public override string ToString() {
      return "-";
    }
  }
}
