﻿//r: Atac.TemplateEngine.Tests.dll

using System.Collections.Generic;
using Atac.TemplateEngine.Tests.MemberNodes;
using CodeGenerator = Atac.TemplateEngine.CodeGenerator<object>;

public class TemplateHandlers {
  private readonly HashSet<string> keywords = new HashSet<string> { "public", "private", "if", "while" };

  public void VarId(object node, CodeGenerator cg) {
    VarId n = (VarId) node;
    if (IsKeyword(n.Name)) {
      cg.PutText("@");
    }
    cg.PutTemplate(node);
  }

  public void VarDeclRecursive(object node, CodeGenerator cg) {
    cg.PutNode(node);
  }

  private bool IsKeyword(string name) {
    return keywords.Contains(name);
  }
}