﻿// Atac Template Engine
// Copyright (C) 2011 Markus Jahn <markus.jahn@gmx.at>
//
// This file is part of Atac Template Engine.
//
// Atac Template Engine is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Atac Template Engine is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Atac Template Engine.  If not, see <http://www.gnu.org/licenses/>.

using System;

namespace Atac.TemplateEngine {
  public class PathItem {
    public string Name { get; private set; }
    public int Index { get; private set; }

    public PathItem(string name)
        : this(name, -1) {
    }

    public PathItem(string name, int index) {
      if (string.IsNullOrEmpty(name)) {
        throw new ArgumentException("Name must not be null or empty", "name");
      }
      Name = name;
      Index = index;
    }

    public override string ToString() {
      return Index < 0 ? Name : string.Format("{0}[{1}]", Name, Index);
    }
  }
}