﻿using System;
using System.IO;
using Atac.TemplateEngine;

namespace Taste {
  internal class Program {
    private static void Main(string[] args) {
      string filename = args.Length > 0 ? args[0] : "Test.TAS";

      Node root = Parse(filename);

      TemplateEngine<Node> templateEngine
          = new TemplateEngine<Node>("TasteToCs.tpl", "TasteToCs.cs");     // template handler from file
      //  = new TemplateEngine<Node>("TasteToCs.tpl", typeof(TasteToCs));  // template handler from type
      //  = new TemplateEngine<Node>("TasteToCs.tpl", new TasteToCs());    // template handler from object
      TextWriter writer
          = Console.Out;                          // write to console
      //  = new StreamWriter(filename + ".cs");   // write to file
      templateEngine.Start(writer, root);

      Console.Write("\nPress any key to exit...");
      Console.ReadKey();
    }

    private static Node Parse(string filename) {
      Scanner scanner = new Scanner(filename);
      Parser parser = new Parser(scanner);
      parser.Parse();
      Console.WriteLine(parser.errors.count + " errors detected");
      Console.WriteLine();
      return parser.errors.count == 0 ? parser.curProc : null;
    }
  }
}

